var onlineusers_widget_alt = function(domain, txtcolor, bgcolor, bghovercolor, cntcolor, bgcntcolor, txtfont, position, _jQ){
    jQ = undefined;
    this.msie = false;
    try {
        if (_jQ) {jQ = _jQ;} else {jQ = jQuery;}
        this.msie = jQ.browser;
        if (this.msie){
            this.msie = this.msie.msie;
        }
        jQ.fn.jquery;
    } catch(e) {
        throw new Error("Online-Radar widget requires jQuery version >= 1.7.1");
    };
    
    var v = jQ.fn.jquery.split('.');
    if ((v[0]<1) || (v[0]==1 && v[1]<7) || (v[0]==1 && v[1]==7 && v[2]<1)){
        throw new Error("Online-Radar widget requires jQuery version >= 1.7.1. Current version is '" + jQ.fn.jquery + "'.");
    };
    
    /* 102 variants:
     * 15 no opt
     * 15 closed
     * 18 fliped
     * 18 flipped+closed
     * 10 hidden
     * 10 hidden+closed
     * 8 flipped+hidden
     * 8 flipped+hidden+closed
     */

    var LEFT = 1,
        CENTER = 2,
        RIGHT = 3,
        HEADER = 4,
        FOOTER = 5,
        TOP = 6,
        BOTTOM = 7;
    var OPT_CLOSE = 0,
        OPT_FLIP = 1,
        OPT_HIDE = 2;

    try {
        this.query_interval = QUERY_INTERVAL_VARIABLE;// interval beetwen send queries
    } catch (e) {
        this.query_interval = 5000;
    };
    
    try {
        this.ID_LEN = ID_LENGTH_VARIABLE;// length of identifies field in bytes
    } catch (e) {
        this.ID_LEN = 20; 
    };

    this.usersonline = '';
    this.query_interval_id = false;
    
    this.active = false;

    var isHidden = false;
    this.isWaited = false, this.isOver = false, this.closeOver = false;
    this.wait_time=0;
    
    this.pos = [];
    
    this.setCookie = function(name, value){
        document.cookie = name+"="+escape(value)+"; PATH=/; DOMAIN="+escape(document.domain);
    };

    this.getCookie = function(name) {
        var cookie = ' ' + document.cookie;
        var search = ' ' + name + '=';
        var setStr = '';
        var offset = 0;
        var end = 0;
        if (cookie.length > 0) {
            offset = cookie.indexOf(search);
            if (offset !== -1) {
                offset += search.length;
                end = cookie.indexOf(';', offset);
                if (end === -1) {
                    end = cookie.length;
                }
                setStr = unescape(cookie.substring(offset, end));
            }
        }
        return(setStr);
    };

    this.getOpenParams = function(){
        var title = document.title;
        var ssid = getCookie('onlineradar_session_id');

        var param = '';
        if (ssid.length){
            param += '&session_id=' + escape(ssid);
        }

        return param;
    };

    this.getStatusParams = function(){
        var ssid = getCookie('onlineradar_session_id');
        var param = '';

        if (ssid.length){
            param += '&session_id=' + escape(ssid);
        }

        return param;
    };

    this.sendRequestError = function(response){
        jQ("#onlineradar_online").html(" ");
        if (response){
            var data = jQ.parseJSON(response);
            data.online = Number(data.online);
            if (data.online === 0){
                data.online = 1;
            }
            if (data.online >= 0){
                jQ("#onlineradar_online").html(data.online);
                setCookie("onlineradar_online", data.online);
            }
        }
    };

    this.sendRequestReady = function(response){
        var self = this;
        // print result
        var data = jQ.parseJSON(response);
        data.online = Number(data.online);
        switch (data.online){
            case -2: // widget is locked
                jQ("#onlineusers_widget").remove();
                clearInterval(self.query_interval_id);
                setCookie("onlineradar_online", data.online);
            case -1: // error
                jQ("#onlineradar_online").html(" ");
                break;
            default: // ok
                var online = data.online;

                if ((Number(getCookie("onlineradar_online")) === -2)&&(online >= 0)){
                    setCookie("onlineradar_online", online);
                    paint();
                }

                if (data.session_id){
                    self.session_id = data.session_id;
                    setCookie('onlineradar_session_id', data.session_id);
                }

                if (online === 0){
                    online = 1;
                } else {
                    if (getCookie('onlineradar_session_id') === ''){//if cookie has disabled
                        online += 1;
                    }
                }

                var oldonline = Number(jQ("#onlineradar_online").html());
                if (online > 9999999){
                    online = '10kk+';
                }
                if (oldonline !== online){
                    jQ("#onlineradar_online").html(online);
                    setCookie("onlineradar_online", online);
                }
        }
    };

    this.sendRequest = function (url){
        var self = this;
        if (this.msie && window.XDomainRequest){
            var xhr = new XDomainRequest();
            xhr.open('GET', url, true);
            xhr.onload = function(){
                self.sendRequestReady(xhr.responseText);
            };
            xhr.onerror = function(){
                self.sendRequestError(xhr.responseText);
            };
            xhr.send();
        } else {
            var xhr = new XMLHttpRequest();
            xhr.open('GET', url, true);
            xhr.onreadystatechange = function(){
                if (xhr.readyState !== 4){
                    return;
                }
                if (xhr.status !== 200) { // error
                    self.sendRequestError(xhr.responseText);
                } else {
                    self.sendRequestReady(xhr.responseText);
                }
            };
            xhr.send();
        }
    };

    this.openPageRequest = function(){
        var param = getOpenParams();

        sendRequest(this.usersonline+'open'+param);
    };

    this.statusRequest = function(){
        var param = getStatusParams();
        sendRequest(this.usersonline+'status'+param);
    };

    this.mouseover = function(){
        jQ('#onlineradar_link').css("backgroundColor", this.colors.bghover);
        jQ('#onlineradar_close').css("opacity", 1);
        this.isOver = true;
    };
    
    this.onhidden_mouseover = function(){
        if (isHidden){
            isHidden = false;
            widgetshow();
        }
    };

    this.mouseleave = function(){
        jQ('#onlineradar_link').css("backgroundColor", this.colors.bg);
        jQ('#onlineradar_close').css("opacity", 0);
        this.isOver = false;
    };

    this.closemouseover = function(){
        jQ('#onlineradar_close').css("backgroundColor", this.colors.bgcnt);
        this.closeOver = true;
    };

    this.closemouseleave = function(){
        jQ('#onlineradar_close').css("backgroundColor", this.colors.bghover);
        this.closeOver = false;
    };

    this.scroll_leftright = function(){
        var wh = jQ('#onlineusers_widget').height(); //widget height
        var top = 0;    //widget top
        var left = (this.pos.position === RIGHT) ? (jQ(window).width()-jQ('#onlineusers_widget').width()) : 0;   //widget left
        switch (this.pos.align){
            case CENTER:
                top = (jQ(window).height()-wh)/2;
                break;
            case BOTTOM:
                top = jQ(window).height()-wh;
                break;
        }

        var ml = 0;//margin left

        if (this.pos.options['hide']){
            jQ('#widget_text').css({"opacity":0});
            ml = (this.pos.position === RIGHT) ? 110 : -115;
            if (this.pos.position === RIGHT){
                jQ('#onlineradar_online').css({"position":"absolute", 'left':58});
            }
        }

        if (this.pos.options['flip']){
            if (!this.pos.options['hide']){
                if (this.pos.position === RIGHT){
                    jQ('#onlineradar_link').css({"border-radius":"15px 15px 0px 0px"}); 
                } else {
                    jQ('#onlineradar_link').css({"border-radius":"0px 0px 15px 15px"});
                }

                jQ('#onlineusers_widget').css({"transform":"rotate(270deg)"});
                ml = (this.pos.position === RIGHT) ? 85 : -85;

                switch (this.pos.align)
                {
                    case BOTTOM:
                        top -= wh;
                        break;
                    case TOP:
                        top += wh;
                        break;
                }
            } else {
                if (this.pos.align === BOTTOM){
                    jQ('#onlineradar_link').css({"border-radius":"15px 15px 0px 0px"}); 
                } else if (this.pos.align === TOP){
                    jQ('#onlineradar_link').css({"border-radius":"0px 0px 15px 15px"});
                }

                switch (this.pos.align)
                {
                    case BOTTOM:
                        top += 10;
                        break;
                    case TOP:
                        top -= 10;
                        break;
                }
            }
        }
        jQ('#onlineusers_widget').css({"position":"fixed", 'left':left, 'top':top, 'z-index':'1000000000', 'margin':'0px 0px 0px '+ml+'px'}).show("slow");
    };

    this.scroll_topbottom = function(){
        var left = 0;
        var top = 0;

        if (this.pos.position === BOTTOM){
            top = jQ(window).height()-jQ('#onlineusers_widget').height();
        }
        switch (this.pos.align){
            case CENTER:
                left = (jQ(window).width() - jQ('#onlineusers_widget').width())/2;
                break;
            case RIGHT:
                left = jQ(window).width() - jQ('#onlineusers_widget').width();
                break;
        }

        if (this.pos.options['flip']){
            if (this.pos.position === BOTTOM){
                jQ('#onlineradar_link').css({"border-radius":"15px 15px 0px 0px"});
                top += 11;
            } else {
                jQ('#onlineradar_link').css({"border-radius":"0px 0px 15px 15px"});
                top -= 11;
            }
        }

        jQ('#onlineusers_widget').css({"position":"fixed", 'left':left, 'top':top, 'z-index':'1000000000'}).show("slow");
    };

    this.scroll_headerfooter = function(){
        var left = 0;
        var top = (this.pos.position === FOOTER) ? this.doc_height - jQ('#onlineusers_widget').height() : 0;

        switch (this.pos.align){
            case CENTER:
                left = (jQ(window).width() - jQ('#onlinusers_widget').width())/2;
                break;
            case RIGHT:
                left = jQ(window).width() - jQ('#onlineusers_widget').width();
                break;
        }
        var ml = 0;
        if (this.pos.options['hide']){
            jQ('#widget_text').css({"opacity":0});
            ml = (this.pos.align === RIGHT) ? 110 : -115;
            if (this.pos.align === RIGHT){
                jQ('#onlineradar_online').css({"position":"absolute", 'left':58});
            }
        } else {
            if (this.pos.options['flip']){
                if (this.pos.position === FOOTER){
                    jQ('#onlineradar_link').css({"border-radius":"15px 15px 0px 0px"});
                    top += 11;
                } else {
                    jQ('#onlineradar_link').css({"border-radius":"0px 0px 15px 15px"});
                    top -= 11;
                }
            }
        }

        jQ('#onlineusers_widget').css({"position":"absolute", 'left':left, 'top':top, 'z-index':'1000000000', 'margin':'0px 0px 0px '+ml+'px'}).show();
    };

    this.setPosition = function(){
        var pos_func;
        var res_func;

        switch (this.pos.position){
            case LEFT:
            case RIGHT:
                res_func = scroll_leftright;
                scroll_leftright();
                break;
                break;
            case TOP:
            case BOTTOM:
                res_func = scroll_topbottom;
                scroll_topbottom();
                break;
            case FOOTER:
            case HEADER:
                if (this.pos.align !== LEFT){
                    res_func = scroll_headerfooter;
                }
                scroll_headerfooter();
                break;
            default:
                jQ('#onlineusers_widget').css({"position":"static", 'z-index':'inherit'}).show('slow');
                pos_func = null;
        };

        if (!!jQ('#onlineusers_widget').offset()){
            jQ(window).scroll(pos_func);
            jQ(window).resize(res_func);
        }
    };

    this.widgethide = function(){
        var self = this;
        
        if (this.isOver){
            return;
        }
        jQ('#onlineradar_link').unbind('mouseleave');
        jQ('#onlineradar_link').unbind('mouseover');

        if (this.pos.position === LEFT || (((this.pos.position === HEADER)||(this.pos.position === FOOTER)) && (this.pos.align === LEFT))){
                jQ('#widget_text').animate({"opacity":0}, 200, function(){
                    jQ('#onlineusers_widget').animate({"margin-left":-120}, 200, function(){
                            isHidden = true;

                            jQ('#onlineradar_link').bind('mouseover', self.onhidden_mouseover);
                        });
                });
        } else {
            if (this.pos.position === RIGHT || (((this.pos.position === HEADER)||(this.pos.position === FOOTER)) && (this.pos.align === RIGHT))){
                jQ('#onlineradar_online').css({"position":"absolute", 'left':130});
                jQ('#onlineradar_online').animate({"position":"absolute", 'left':58}, 200);
                jQ('#widget_text').animate({"opacity":0}, 200);
                jQ('#onlineusers_widget').animate({"margin-left":110}, 200, function(){
                        isHidden = true;

                        jQ('#onlineradar_link').bind('mouseover', self.onhidden_mouseover);
                    });
            }
        }
    };

    this.waithide = function(){
        jQ('#onlineradar_close').css("backgroundColor", this.bghovercolor);

        if (this.isOver){
            this.isWaited = false;
            return;
        }
        if (this.wait_time >= 1500) {
            this.isWaited = false;
            widgethide();
            return;
        }

        this.wait_time += 50;
        setTimeout('this.waithide();', 50);
    };

    this.widgetshow = function(){
        var self = this;
        jQ('#onlineradar_link').bind('mouseleave', function(){
            if (!self.isWaited){
                self.isWaited = true;
                isHidden = false;
                self.wait_time = 0;
                setTimeout('this.waithide();', 50);
            }
        });

        if ((pos.position === LEFT) || (((pos.position === HEADER)||(pos.position === FOOTER)) && (pos.align === LEFT))){
                jQ('#onlineusers_widget').animate({"margin-left":-29}, 200);
                jQ('#widget_text').animate({"opacity":1}, 2);
        } else {
            if (pos.position === RIGHT || (((pos.position === HEADER)||(pos.position === FOOTER)) && (pos.align === RIGHT))){
                jQ('#onlineradar_online').css({"position":"static"});
                jQ('#onlineusers_widget').animate({"margin-left":29}, 200);
                jQ('#widget_text').animate({"opacity":1}, 400);
            }
        }
        /*jQ("#onlineradar_link").attr('href', this.linkhref);*/
    };

    this.clickWidget = function(){
        if (this.closeOver){
            /*jQ('#onlineradar_link').removeAttr('href');*/
            jQ('#onlineusers_widget').hide('fast');
            return;
        }

        /*jQ('#onlineradar_link').href = this.linkhref;*/
    };

    this.initPosition = function(){
        this.pos = [];
        
        var options = Number(this.position) % 10;
        this.pos.align = Math.floor(Number(this.position) / 10 % 10);
        this.pos.position = Math.floor(Number(this.position) / 100 % 10);
        this.pos.options = [];
        if ((options > 7) || (options < 0)){
           options = 0;
        }

        this.pos.options["close"] = (1 << OPT_CLOSE & options) !== 0;
        this.pos.options["hide"] = (1 << OPT_HIDE & options) !== 0;
        this.pos.options["flip"] = (1 << OPT_FLIP & options) !== 0;

        switch (this.pos.position){
            case LEFT:
            case RIGHT:
                if ((this.pos.align !== TOP) && (this.pos.align !== BOTTOM) && (this.pos.align !== CENTER)){
                    this.pos.align = TOP;
                }
                break;
            case TOP:
            case BOTTOM:
                if (this.pos.options["hide"]){
                    if (this.pos.align === CENTER){
                        this.pos.options["hide"] = false;
                        break;
                    }
                    this.pos.position += this.pos.align;
                    this.pos.align = this.pos.position - this.pos.align;
                    this.pos.position -= this.pos.align;
                    break;
                }
            case HEADER:
            case FOOTER:
                if (this.pos.options["hide"]){
                    if (this.pos.align === CENTER){
                        this.pos.options["hide"] = false;
                        break;
                    }
                }
                if ((this.pos.align !== RIGHT) && (pos.align !== LEFT) && (pos.align !== CENTER)){
                    this.pos.align = LEFT;
                }
                break;
            default:
                this.pos.options["hide"] = false;
                this.pos.options["flip"] = false;
                this.pos.position = 0;
                this.pos.align = 0;
        }
    };

    this.paint = function(){
        var online = getCookie("onlineradar_online");
        if (Number(online) === -2){
            return;
        }

        var widget = jQ('#onlineusers_widget');
        if (!widget){
            widget = jQ(document).append('<div id="onlineusers_widget"></div>');
        }

        widget.css(
                {'width':'200px', 'position':'fixed', 'line-height':'1', 'font-family':txtfont, 'font-size':'14px', 'box-sizing':'border-box', 'display':'block', 'margin':'0px 0px 0px 0px'}
                ).html('<ul onmousedown="clickWidget()"; style="padding-left:0; margin:10px 0; text-align:center; list-style-type:none; list-style-position:outside; list-style-image:none; background-color:none;"><li>'
            +'<a onmouseover="mouseover()"; onmouseleave="mouseleave()"; id="onlineradar_link"; target="_blank"; style="display:inline-block; padding:5px 10px 5px '+(this.pos.options["close"] ? '5' : '20')+'px; background-color:'+this.colors.bg+'; border:0px solid #ddd; border-radius:15px; cursor:pointer; text-decoration:none; color:'+this.colors.txt+'; box-shadow:2px 2px 4px rgba(0,0,0,0.2);">'
            +(this.pos.options["close"] ? '<block id="onlineradar_close"; onmouseover="closemouseover()"; onmouseleave="closemouseleave()"; style="display:inline-block; margin:0px 0px 0px 0px; padding:2px 4px; font-size:10px; font-weight:bold; line-height:1; color:'+this.colors.cnt+'; text-align:center; white-space:nowrap; vertical-align:middle; background-color:'+this.colors.bghover+'; border-radius:90px; opacity:0; font-family:Trebuchet MS;">x</block>' : '')
            +'<block id="widget_text">Users online  </block>'
            +'<span id="onlineradar_online"; style="display:inline-block; min-width:10px; padding:3px 7px; font-size:12px; font-weight:bold; line-height:1; color:'+this.colors.cnt+'; text-align:center; white-space:nowrap; vertical-align:middle; background-color:'+this.colors.bgcnt+'; border-radius:10px;">'+online+'</span>'
            +'</a></li></ul>');

        widget.click(this.clickWidget);
        if (this.pos.options["hide"]){
            jQ('#onlineradar_link').bind('mouseover', this.widgetshow);
        }
        setPosition();
    };

    this.init = function(domain, txtcolor, bgcolor, bghovercolor, cntcolor, bgcntcolor, txtfont, position) {
        var self = this;
        this.usersonline = domain;
        this.doc_height = jQ(document).height();
        
        if (txtcolor == false || txtcolor==undefined){
            txtcolor="#337ab7";
        }
        if (bgcolor == false || bgcolor==undefined){
            bgcolor="#fff";
        }
        if (bghovercolor == false || bghovercolor==undefined){
            bghovercolor="#eee";
        }
        if (cntcolor == false || cntcolor==undefined){
            cntcolor="#fff";
        } 
        if (bgcntcolor == false || bgcntcolor==undefined){
            bgcntcolor="#777";
        }
        if (txtfont == false || txtfont==undefined){
            txtfont="Helvetica Neue, Helvetica, Arial, sans-serif";
        }
        this.colors=[];
        this.colors.txt = txtcolor;
        this.colors.bg = bgcolor;
        this.colors.bghover = bghovercolor;
        this.colors.cnt = cntcolor;
        this.colors.bgcnt = bgcntcolor;
        
        this.txtfont = txtfont;
        this.position = position;
        
        initPosition();
        paint();
        
        self.session_id = getCookie('onlineradar_session_id');
        
        openPageRequest();
            
        this.query_interval_id = setInterval('this.statusRequest();', this.query_interval);
    };
    
    this.init(domain, txtcolor, bgcolor, bghovercolor, cntcolor, bgcntcolor, txtfont, position);
};